#ifndef POINT_H
#define POINT_H

#include "aliases.h"
#include <stdio.h>

struct Point {
  f64 x;
  f64 y;
};

struct PointPair {
  Point p1;
  Point p2;
};

struct PairArray {
  u64 count;
  PointPair *pairs;
};

void write_pairs_to_binary(const PairArray &arr, const char *filename);
void read_pairs_from_binary(PairArray &arr, const char *filename);
void write_pairs_to_json(const PairArray &arr, const char *filename);
bool compare_pair_array(const PairArray &arr1, const PairArray &arr2);

#endif // !POINT_H
